//
//  MyTextField.m
//  DragPathForPascal
//
//  Created by Cyril Godefroy on Sat Feb 23 2002.
//  Copyright (c) 2002 . All rights reserved.
//

// most of this stollen from Cyril. Thanks man!

#import "myView.h"

#define over 0
#define notComplete 1
#define complete 2
#define maxWidth 113
#define maxHeight 70

@implementation myView

- (void)setup:(NSString *)nameS
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	float middleX, middleY;
	
    droppedOn = [[NSMutableString alloc] initWithCapacity :20];
	droppedFiles = [[NSMutableArray alloc] initWithCapacity:1];
	[droppedFiles retain];
    name = nameS;
    if ( [name isEqualToString :@"source"] ){
        well = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"sourcewell" ofType:@"tiff"]];
        folder = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"folder" ofType:@"tiff"]];
		
    }
    if ( [name isEqualToString :@"destination"] ){
        well = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"destwell" ofType:@"tiff"]];
        folder = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"folder" ofType:@"tiff"]];
    }
    if ( [name isEqualToString :@"copyright"] ){
		NSImage *temp;
        well = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"copyrightwell" ofType:@"tiff"]];
        folder = [[NSImage allocWithZone:[self zone]] initWithContentsOfFile: [[NSBundle bundleForClass:[self class]] pathForResource:@"copyrightwellgray" ofType:@"tiff"]];
		if ( [defaults objectForKey :@"copyrightPict"] != nil ){
			[droppedOn setString : [defaults objectForKey :@"copyrightPict"]];
			//			NSLog (droppedOn);
			temp = [[NSImage alloc] initWithContentsOfFile: droppedOn];
			if ( temp != nil ){
				// there is a copyright from last time
				if ( [temp size].width > maxWidth || [temp size].height > maxHeight ){ // here's my cute little scale code. Basically it checks which side is bigger
					
					[temp setScalesWhenResized :YES];
					
					if ( (maxHeight / [temp size].height ) * [temp size].width <= maxWidth && (maxHeight / [temp size].height ) * [temp size].height <= maxHeight){
						//			NSLog (@"scale 1");			
						[temp setSize :NSMakeSize([temp size].width * ( maxHeight / [temp size].height ), [temp size].height * ( maxHeight / [temp size].height ) ) ];
					} else {
						//			NSLog (@"scale 2");			
						[temp setSize :NSMakeSize([temp size].width * ( maxWidth / [temp size].width ), [temp size].height * ( maxWidth / [temp size].width ) )  ];
					}
					
					if ( [temp size].width < maxWidth ) { // We'll need to center it
						middleX = (maxWidth - [temp size].width ) / 2;
					} else {
						middleX = 0.0;
					}
					
					if ( [temp size].height < maxHeight ) { // We'll need to center it
						middleY = (maxHeight - [temp size].height ) / 2;
					} else {
						middleY = 0.0;
					}
					
					[well lockFocus];
					[[NSColor whiteColor] set];
					NSRectFill (NSMakeRect( 0, 0.0, maxWidth, maxHeight )); 
					[temp compositeToPoint:NSMakePoint(middleX, middleY )
								  fromRect:NSMakeRect( 0, 0.0, maxWidth, maxHeight )
								 operation:NSCompositeSourceOver];
					[well unlockFocus];
					state = complete;
				}
			}
		}
	}
	state = -1;
	[self registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
}

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender {
	//    NSLog (name);
	if ( state != complete ) // once I complete, I don't want to uncomplete again!
		state = over;
	[self setNeedsDisplay: YES];
	if ([sender draggingSource] != self) {
		NSPasteboard *pb = [sender draggingPasteboard];
		NSString *type = [pb availableTypeFromArray:[NSArray arrayWithObject:NSFilenamesPboardType]];
		if (type != nil) {
			return NSDragOperationCopy;
		}
	}
	return NSDragOperationNone;
}

- (void)draggingExited:(id <NSDraggingInfo>)sender {
	//     NSLog (@"draggingExited");
	if ( state != complete ) // once I complete, I don't want to uncomplete again!
		state = notComplete;
	[self setNeedsDisplay: YES];
	
}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender {
	NSImage *temp;
	BOOL isDir;
	NSFileManager *manager = [NSFileManager defaultManager];
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	float middleX, middleY;
	
	//     NSLog (@"performDragOperation");
	NSPasteboard *pb = [sender draggingPasteboard];
	NSString *type = [pb availableTypeFromArray:[NSArray arrayWithObject:NSFilenamesPboardType]];
	NSArray *array = [[pb stringForType:type] propertyList];
	[droppedOn setString: [array objectAtIndex:0]];
	[droppedFiles removeAllObjects];
	
	// many error checking things here
	if ( [name isEqualToString :@"copyright"] ){
		if ([manager fileExistsAtPath:droppedOn isDirectory:&isDir] && isDir) {
			NSRunAlertPanel(@"My Apologies",@"Please drop the actual file here.",@"OK",NULL,NULL);
			if ( state != complete )
				state = -1;
			[self setNeedsDisplay: YES];
			return NO;
		}
		temp = [[NSImage alloc] initWithContentsOfFile: droppedOn];
		if ( temp == nil ){
			NSRunAlertPanel(@"My Apologies",@"That doesn't seem to be an image format I am familiar with.\nI can not use it.",@"OK",NULL,NULL);
			return NO;
		}
		// scale the image if it's too big
		if ( [temp size].width > maxWidth || [temp size].height > maxHeight ){ // here's my cute little scale code. Basically it checks which side is bigger
			
			[temp setScalesWhenResized :YES];
			
			if ( (maxHeight / [temp size].height ) * [temp size].width <= maxWidth && (maxHeight / [temp size].height ) * [temp size].height <= maxHeight){
				//			NSLog (@"scale 1");			
				[temp setSize :NSMakeSize([temp size].width * ( maxHeight / [temp size].height ), [temp size].height * ( maxHeight / [temp size].height ) ) ];
			} else {
				//			NSLog (@"scale 2");			
				[temp setSize :NSMakeSize([temp size].width * ( maxWidth / [temp size].width ), [temp size].height * ( maxWidth / [temp size].width ) )  ];
			}
		}
		
		if ( [temp size].width < maxWidth ) { // We'll need to center it
			middleX = (maxWidth - [temp size].width ) / 2;
		} else {
			middleX = 0.0;
		}
		
		if ( [temp size].height < maxHeight ) { // We'll need to center it
			middleY = (maxHeight - [temp size].height ) / 2;
		} else {
			middleY = 0.0;
		}
		[folder lockFocus];
		[[NSColor whiteColor] set];
		NSRectFill (NSMakeRect( 0, 0.0, maxWidth, maxHeight )); 
		[temp compositeToPoint:NSMakePoint( middleX, middleY )
					  fromRect:NSMakeRect( 0, 0.0, maxWidth, maxHeight )
					 operation:NSCompositeSourceOver];
		[folder unlockFocus];
		[self setNeedsDisplay: YES];
		[defaults setObject:droppedOn forKey :@"copyrightPict"];
	}
	else {
		NSPasteboard *pboard = [sender draggingPasteboard];
		
		[droppedFiles addObjectsFromArray: [pboard propertyListForType:NSFilenamesPboardType]];
		//      int numberOfFiles = [droppedFiles count];
		//		NSLog(@"%d", numberOfFiles);
		//		if ([manager fileExistsAtPath:droppedOn isDirectory:&isDir] && !isDir) {
		//			NSRunAlertPanel(@"My Apologies",@"Please drop only folders here. Not individual files.",@"OK",NULL,NULL);
		//			if ( state != complete )
		//				state = -1;
		//			[self setNeedsDisplay: YES];
		//			return NO;
		//		}
		//		
	}
	[self setToolTip :droppedOn];
	return YES;
}

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender {
	//    NSLog (@"prepareForDragOperation");
	
	return YES;
}

- (void)concludeDragOperation:(id <NSDraggingInfo>)sender {
	state = complete;
	//     NSLog (@"concludeDragOperation");
}

- (BOOL)droppedOnEmpty
{
	return [droppedOn length] == 0;
}

- (void)drawRect:(NSRect)rect
{
	
	[well compositeToPoint:NSMakePoint( 0.0, 0.0 )
				  fromRect:NSMakeRect( 0, 0.0, maxWidth, 115 )
				 operation:NSCompositeSourceOver];
	if ( state == over || state == complete )
		[folder compositeToPoint:NSMakePoint( 0.0, 0.0 )
						fromRect:NSMakeRect( 0, 0.0, maxWidth, 115 )						operation:NSCompositeSourceOver];
	
}

- (NSMutableArray *)theDroppedFiles
{
	return droppedFiles;
}

- (NSString *)path
{
	return droppedOn;
}

- (void) dealloc
{
	[name release];
	[droppedOn release];
	[droppedFiles release];
	[folder release];
	[well release];
	[super dealloc];
}
@end
