#import "myWindow.h"

//copyrightPict

@implementation myWindow

- (void)awakeFromNib{

	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	
    [self center];
    // these are all the same class, they react just a little differently, based on the name
    sourceView = [[myView alloc] initWithFrame: NSMakeRect(32, 430, 113, 115)];
    [[self contentView] addSubview : sourceView];
    [sourceView setup :@"source"];

    destinationView = [[myView alloc] initWithFrame: NSMakeRect(211, 430, 113, 115)];
    [[self contentView] addSubview : destinationView];
    [destinationView setup :@"destination"];

    copyrightView = [[myView alloc] initWithFrame: NSMakeRect(118, 330, 113, 70)];
    [[self contentView] addSubview : copyrightView];
    [copyrightView setup :@"copyright"];

    shouldContinue = 1;

	if ( [defaults stringForKey :@"copyrightPict"] == nil ){
		[locationChoice selectCellWithTag :4];
		[transparecySlider setIntValue: 50];
	}
	else {
		[locationChoice selectCellWithTag :[defaults integerForKey: @"position"]];
		[transparecySlider setIntValue: [defaults integerForKey :@"transparancy"]];
		[defaults synchronize];
	}
}

- (IBAction)go:(id)sender
{
	BOOL completeSourceLine = NO;
	
    if ( ![sourceView droppedOnEmpty] && ![copyrightView droppedOnEmpty] ){

        int howMany;
        int lcv;
		
		NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        NSImage *copyrightImage = [[NSImage alloc] initWithContentsOfFile: [copyrightView path]]; // wish I knew how to load a new picture without doing the initWith thing. Does this leak?

        NSMutableArray *picturesToDo = [NSMutableArray arrayWithCapacity : 10];

        NSDirectoryEnumerator *enumerator_;

        if ( copyrightImage == nil ){
            NSRunAlertPanel(@"My Apologies",@"I can't seem to open your copyright image. Make sure it's a picture in a common format: jpg, tiff, gif, etc.",@"OK",NULL,NULL);
            return;
        } else {
			[defaults setObject:[copyrightView path] forKey: @"copyrightPict"];
		}

        enumerator_= [[[NSFileManager defaultManager] enumeratorAtPath:[sourceView path]] retain];
        [picturesToDo addObjectsFromArray: [enumerator_ allObjects]]; // I get all of them this way
		
        howMany = [picturesToDo count];	// so that I can get a count of them easily

        if (howMany == 0) {
			
			[picturesToDo addObjectsFromArray:[sourceView theDroppedFiles]];
			completeSourceLine = YES;
			 howMany = [picturesToDo count];	// so that I can get a count of them easily
			 if (howMany == 0) { // still equaling 0, there's a problem	
				 NSRunAlertPanel(@"My Apologies",@"Your source folder appears to be empty.",@"OK",NULL,NULL);
				 return;
			 }
        } else {
			[defaults setInteger: [[locationChoice selectedCell] tag] forKey: @"position"];
			[defaults setInteger: [transparecySlider intValue] forKey :@"transparancy"];
		}


        [progressIndicator setMaxValue :howMany - 1];
        [progressIndicator setDoubleValue :0.0];

		manualMode = [[manualView alloc] initWithFrame: NSMakeRect( 0, 0, 640, 480)];
		[manualMode retain];
		[scrollView setHasVerticalScroller: YES];
		[scrollView setHasHorizontalScroller: YES];

		[scrollView setDocumentView: manualMode];
		[scrollView setFrame :NSMakeRect( 0, 20, 640, 480 )];

        [progressWindow center];
        [progressWindow makeKeyAndOrderFront: nil]; // bring it up
//		NSLog ([picturesToDo description]);
		if ( [[locationChoice selectedCell] tag] != 10 ){
			for ( lcv = 0; lcv < howMany; lcv++ ){
				[self processImage :[picturesToDo objectAtIndex: lcv] :copyrightImage :completeSourceLine];
			}
		} else {
			if ( ![destinationView droppedOnEmpty] )
				// doing the / and /c_ here makes sure the manual way doesn't overwrite the picture, as doManualWay has certain assumptions I'm
				// too lazy to fix now
				[manualMode doManualWay :[sourceView path] :[NSString stringWithFormat: @"%@/", [destinationView path]] :picturesToDo :completeSourceLine :[copyrightView path] :[destinationView droppedOnEmpty] :[transparecySlider doubleValue] * .01 :[resizeX intValue] :[resizeY intValue] :[resizePercent intValue]];
			else
				[manualMode doManualWay :[sourceView path] :[NSString stringWithFormat: @"%@/c_", [sourceView path]] :picturesToDo :completeSourceLine :[copyrightView path] :[destinationView droppedOnEmpty] :[transparecySlider doubleValue] * .01 :[resizeX intValue] :[resizeY intValue] :[resizePercent intValue]];

			[enumerator_ release];
			[picturesToDo removeAllObjects];
			return;
		}
		[defaults synchronize];
        [enumerator_ release];
        [picturesToDo removeAllObjects];
        NSRunAlertPanel(@"Complete",@"I have completed that action.",@"OK",NULL,NULL);
        [progressWindow close];
        shouldContinue = 1;
    }
    else
        NSRunAlertPanel(@"My Apologies",@"I have not yet received all critical pieces of information.\nPlease choose source, destination and image to composite.",@"OK",NULL,NULL);
}

- (IBAction)savePrefencesWindow:(id)sender
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	float compressionValue = [preferencesField floatValue];
	if ( compressionValue >= 1 & compressionValue <= 10 ){
		[defaults setFloat:compressionValue/10 forKey: @"compression"];
		[defaults synchronize];
		[preferencesWindow close];
	}
	else {
		NSBeep();
		NSRunAlertPanel(@"My Apologies",@"Please enter a number between 1 and 10.",@"OK",NULL,NULL);
	}
}

- (IBAction)cancelPrefencesWindow:(id)sender
{
	[preferencesWindow close];
}


- (IBAction)openPrefencesWindow:(id)sender
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	float compression = [defaults floatForKey :@"compression"];
	
	if (compression == 0){
		compression = .9;
		[defaults setFloat:compression forKey: @"compression"];
	}
	[defaults synchronize];
	[preferencesField setIntValue: compression*10];
	[preferencesWindow center];
	[preferencesWindow makeKeyAndOrderFront: nil]; // bring it up
}

- (IBAction)cancel:(id)sender // for some reason this didn't work, so I took the cancel button out.
{
//    NSLog (@"I'm canceling");
    shouldContinue = 0;
}

- (BOOL) applicationShouldTerminateAfterLastWindowClosed:(NSApplication *) theApplication
{
    return YES;
}

- (void)processImage: (NSString *)theImage :(NSImage *)copyrightImage :(BOOL) completeString
{
	NSAutoreleasePool *pool; //Also, if you need to write a loop that creates many temporary objects, you should create an autorelease pool 
	// in the loop to prevent too long a delay in the disposal of those objects.
	// that's what was happening- the pictures were hanging around too long in memory even though they had been "released". So this gets rid
	// of them right away. At the cost of a little time for garbage collection. Better that then chewing through all your memory though!

	NSImage *sourceImage;
    NSBitmapImageRep* imageRep;
    NSSize imageSize;
    NSString *type;
    NSRect rect;
    NSBitmapImageFileType typeCode = -99;
    float compression = 0.0;
    int placeCopyrightX = 0, placeCopyrightY = 0;
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSData              *colorSyncProfile = nil;
	
	compression = [defaults floatForKey :@"compression"];
	
	if (compression == 0){
		compression = .9;
		[defaults setInteger:compression forKey: @"compression"];
	}

	pool = [[NSAutoreleasePool alloc] init];
	
	if (!completeString){
		sourceImage = [[NSImage alloc] initByReferencingFile:[NSString stringWithFormat: @"%@/%@", [sourceView path], theImage]]; // wish I knew how to load a new picture without doing the initWith thing. Does this leak?
	}else {
		sourceImage = [[NSImage alloc] initByReferencingFile: theImage];

	}
	
    if ( ![sourceImage isValid] ){// who knows what it is
		NSLog (@"File %@ is invalid or corrupt", theImage);
        return; // skip it
	}

	[sourceImage setScalesWhenResized :YES];

	if ( [[resizeChoice selectedCell] tag] == 1 ){
		[sourceImage lockFocus];
		if ( [resizePercent intValue] == 0 )
			[sourceImage setSize :NSMakeSize([resizeX intValue], [resizeY intValue])];
		else
			[sourceImage setSize :NSMakeSize((int)([sourceImage size].width * ([resizePercent intValue] * .01)), (int)([sourceImage size].height * ([resizePercent intValue] * .01)))]; // here's the line that puts it back
		[sourceImage unlockFocus];
	}
	
    type = [[theImage pathExtension] lowercaseString]; // get a dictionary of values from the file manager about this file and get the type from them
                                                                                //            NSLog (type);

    if ( [type isEqualTo: @"pict"] || [type isEqualTo: @"pct"] || [type isEqualTo: @"PICT"] || [type isEqualTo: @"PCT"]){
        NSRunAlertPanel(@"My Apologies",@"I regret to say I can not not process the PICT format at this time.\nThis is because I can't find its dimentions.\nSorry",@"OK",NULL,NULL);

        return;
    }

	if ( [type isEqualTo: @"jpg"] || [type isEqualTo: @"jpeg"] || [type isEqualTo: @"JPG"] || [type isEqualTo: @"JPEG"] )
		typeCode = NSJPEGFileType;
	
	if ( [type isEqualTo: @"gif"] || [type isEqualTo: @"GIF"])
		typeCode = NSGIFFileType;
	if ( [type isEqualTo: @"png"] || [type isEqualTo: @"PNG"])
		typeCode = NSPNGFileType;
	if ( [type isEqualTo: @"bmp"] || [type isEqualTo: @"BMP"])
		typeCode = NSBMPFileType;
	if ( [type isEqualTo: @"tiff"]  || [type isEqualTo: @"TIF"] || [type isEqualTo: @"TIFF"] || [type isEqualTo: @"tif"])
		typeCode = NSTIFFFileType;
	
    if ( typeCode == -99 ) { // it didn't change. I don't know what to do with it.
                             //                NSLog (@"Code didn't change on %@", type );
        return;
    }

	
    NSBitmapImageRep *TIFFRep = [[NSBitmapImageRep alloc] initWithData:[sourceImage TIFFRepresentation]];
    imageSize = NSMakeSize([TIFFRep pixelsWide], [TIFFRep pixelsHigh]);
	colorSyncProfile = [[TIFFRep valueForProperty:NSImageColorSyncProfileData] copy];
	NSBitmapImageRep *exifCopy;
	
	if (!completeString){
		exifCopy = [NSBitmapImageRep imageRepWithContentsOfFile:[NSString stringWithFormat: @"%@/%@", [sourceView path], theImage]] ;
	}else {
		exifCopy = [NSBitmapImageRep imageRepWithContentsOfFile:theImage] ;
		
	}
	
	//	NSLog(@"creation date of %@ : %@",path, [[imageTest valueForProperty:@"NSImageEXIFData"] valueForKey:@"DateTimeOriginal"]) ;

    //	find the pos of the copyright based on the size of it and the size of the temp image
    
    if ( [[locationChoice selectedCell] tag] == 2 ){ // lower left
        placeCopyrightX = 0;
        placeCopyrightY = 0;
    }

    if ( [[locationChoice selectedCell] tag] == 1 ){ // left center
        placeCopyrightX = 0;
        placeCopyrightY = (imageSize.height / 2) - ([copyrightImage size].height / 2);
    }

    if ( [[locationChoice selectedCell] tag] == 0 ){ // upper left
        placeCopyrightX = 0;
        placeCopyrightY = imageSize.height - [copyrightImage size].height;
    }

    if ( [[locationChoice selectedCell] tag] == 5 ){ // bottom
        placeCopyrightX = (imageSize.width / 2) - ([copyrightImage size].width / 2);
        placeCopyrightY = 0;
    }

    if ( [[locationChoice selectedCell] tag] == 4 ){ // center
        placeCopyrightX = (imageSize.width / 2) - ([copyrightImage size].width / 2);
        placeCopyrightY = (imageSize.height / 2) - ([copyrightImage size].height / 2);
    }

    if ( [[locationChoice selectedCell] tag] == 3 ){ // top
        placeCopyrightX = (imageSize.width / 2) - ([copyrightImage size].width / 2);
        placeCopyrightY = imageSize.height - [copyrightImage size].height;
    }

    if ( [[locationChoice selectedCell] tag] == 8 ){ // right bottom
        placeCopyrightX = imageSize.width - [copyrightImage size].width;
        placeCopyrightY = 0;
    }

    if ( [[locationChoice selectedCell] tag] == 7 ){ // right center
        placeCopyrightX = imageSize.width - [copyrightImage size].width;
        placeCopyrightY = (imageSize.height / 2) - ([copyrightImage size].height / 2);
    }

    if ( [[locationChoice selectedCell] tag] == 6 ){ // right top
        placeCopyrightX = imageSize.width - [copyrightImage size].width;
        placeCopyrightY = imageSize.height - [copyrightImage size].height;
    }
    
//NSLog (@"%f", [transparecySlider doubleValue] *.01 );
//NSLog ( @"%f, %f", [TIFFRep size].width, [TIFFRep size].height );
//NSLog ( @"%d", [TIFFRep pixelsWide] );
//NSLog ( @"%f\n*****", [TIFFRep pixelsWide]/[sourceImage size].width );
	
	[sourceImage setScalesWhenResized :YES];
    if ( [TIFFRep pixelsWide] != [sourceImage size].width ){
//NSLog (@"My dpi is not 72");
        [sourceImage setSize :NSMakeSize ([TIFFRep pixelsWide], [TIFFRep pixelsHigh])];
        // this has to happen because when I lockfocus on something, I get a 72 dpi version of it
        // So, I expand the picture to be the number of pixels in the picture, not the size of the picture
        // so I don't loose any pixels. Then later the 72 version gets turned back into the right
        // size (points, or inches) which is the original dpi
    }
//NSLog ( @"%@", [[[sourceImage representations] objectAtIndex: 0] description]  );

    [sourceImage lockFocus];
    [copyrightImage dissolveToPoint:NSMakePoint(placeCopyrightX, placeCopyrightY) fraction:[transparecySlider doubleValue] * .01];
    // now, put the image in the right place relating to where they have chosen
	
    rect = NSMakeRect(0, 0, [sourceImage size].width, [sourceImage size].height);
    imageRep = [[NSBitmapImageRep alloc] initWithFocusedViewRect:rect];
    // you'll see that rect thing. What happens here is that if I tried
    // NSImageRep *imageRep = [sourceImage bestRepresentationForDevice:nil];
    // it wouldn't work. You'll see a bit lower I ask for what the NSBitmapImageRep is and
    // I get back a NSBitmapImageRep. HUH? Seems that once I lockFocus on the image I can't
    // use it anymore as an NSImageRep, because it turns into an NSCachedImageRep.
    // So, I get the pixels this way

//    if ( imageRep == nil )
//NSLog (@"It's NILL!");
//NSLog (@"It's an %@", [[NSBitmapImageRep class] description] );
	if (![imageRep isKindOfClass:[NSBitmapImageRep class]]) {
		NSRunAlertPanel( @"My Apologies",  @"There was something wrong with that image", @"Ok", nil, nil );
		return;
	}

	[sourceImage unlockFocus];
	[manualMode nextImage :sourceImage];
	[manualMode display:640  :501 :[[locationChoice selectedCell] tag] != 10];

//NSLog ( @"%@\n imageRep is:", [sourceImage description]  );
//NSLog (@"The number of array ellements is: %d", [[sourceImage representations] count]);
	
    [imageRep setSize :NSMakeSize([TIFFRep size].width, [TIFFRep size].height)]; // here's the line that puts it back
    // to the original dpi. If it's 72, it just gets put back the way it was
//NSLog ([imageRep description]);
//NSLog ( @"So, what written is %@", [imageRep description]);

	[imageRep setProperty:NSImageColorSyncProfileData withValue:colorSyncProfile];
	//NSLog (@"Going to write:");
	//NSLog ([[exifCopy valueForProperty:@"NSImageEXIFData"] description]);
	[imageRep setProperty:NSImageEXIFData withValue:[exifCopy valueForProperty:@"NSImageEXIFData"]];
// this enormous thing gives me an NSData stream which I then write out to the disk
	if ( ![destinationView droppedOnEmpty] )
		[[imageRep representationUsingType:typeCode properties:[NSDictionary dictionaryWithObject:[NSNumber numberWithFloat:compression] forKey:NSImageCompressionFactor]] writeToFile:[NSString stringWithFormat :@"%@/%@", [destinationView path], [theImage lastPathComponent]] atomically:YES];
	else
		[[imageRep representationUsingType:typeCode properties:[NSDictionary dictionaryWithObject:[NSNumber numberWithFloat:compression] forKey:NSImageCompressionFactor]] writeToFile:[NSString stringWithFormat :@"%@/c_%@", [sourceView path], theImage] atomically:YES];


    //	write the image to the destination folder with the name of the source using the format
    [progressIndicator incrementBy: 1];
    [progressIndicator displayIfNeeded];
    // they should all be autoreleased

	[TIFFRep release];
    [imageRep release];
    imageRep = nil;
    [sourceImage release];
    sourceImage = nil;
	[pool release];

}

- (void) dealloc
{
    [sourceView release];
    [destinationView release];
    [copyrightView release];
	[super dealloc];   
}

@end